commit 3dea90505df136a4b361665772ef8e62306cfcdb
Author: Richard Biener <rguenther@suse.de>
Date:   Wed Nov 10 11:08:03 2021

    testsuite/102690 - XFAIL g++.dg/warn/Warray-bounds-16.C
    
    This XFAILs the bogus diagnostic test and rectifies the expectation
    on the optimization.
    
    2021-11-10  Richard Biener  <rguenther@suse.de>
    
            PR testsuite/102690
            * g++.dg/warn/Warray-bounds-16.C: XFAIL diagnostic part
            and optimization.
    
    (cherry picked from commit b2cd32b743ba440e75505ce30c6b5c592ed144ea)

diff --git a/gcc/testsuite/g++.dg/warn/Warray-bounds-16.C b/gcc/testsuite/g++.dg/warn/Warray-bounds-16.C
index 17b4d0d194e..89cbadb91c7 100644
--- a/gcc/testsuite/g++.dg/warn/Warray-bounds-16.C
+++ b/gcc/testsuite/g++.dg/warn/Warray-bounds-16.C
@@ -19,11 +19,11 @@ struct S
     p = (int*) new unsigned char [sizeof (int) * m];
 
     for (int i = 0; i < m; i++)
-      new (p + i) int ();
+      new (p + i) int (); /* { dg-bogus "bounds" "pr102690" { xfail *-*-* } } */
   }
 };
 
 S a (0);
 
-/* Verify the loop has been eliminated.
-   { dg-final { scan-tree-dump-not "goto" "optimized" } } */
+/* The loop cannot be eliminated since the global 'new' can change 'm'.  */
+/* { dg-final { scan-tree-dump-not "goto" "optimized" { xfail *-*-* } } } */

